MODULE MODD_CHECK_TEB

IMPLICIT NONE

TYPE CHECK_TEB_t
!
  REAL                :: XCHECK_PROCESS
  REAL                :: XCHECK_ALL
  !
  LOGICAL             :: LCHECK_TEB
  !
  !
  REAL, DIMENSION(:), ALLOCATABLE  :: XFLUXFLOOR          ! Heat flux into the ground floor
  REAL, DIMENSION(:), ALLOCATABLE  :: XFLX_BLD_ROOF       ! Heat exchange between roof and indoor air
  REAL, DIMENSION(:), ALLOCATABLE  :: XFLX_BLD_WALL_A     ! Heat exchange between wall A and indoor air
  REAL, DIMENSION(:), ALLOCATABLE  :: XFLX_BLD_WALL_B     ! Heat exchange between wall B and indoor air
  !
  REAL, DIMENSION(:), ALLOCATABLE  :: XHEAT_RR_ROAD
  REAL, DIMENSION(:), ALLOCATABLE  :: XHEAT_RR_ROOF
  !
  REAL, DIMENSION(:), ALLOCATABLE :: XSEN_SNOW_DIF_ROAD ! Sensible heat due to snowfall on road
  REAL, DIMENSION(:), ALLOCATABLE :: XSEN_SNOW_DIF_ROOF ! Sensible heat due to snowfall on roof
  !
  REAL, DIMENSION(:), ALLOCATABLE :: XDIAG_DCS_AREA
  !
  REAL, DIMENSION(:), ALLOCATABLE :: XSEN_GREENROOF
  REAL, DIMENSION(:), ALLOCATABLE :: XLAT_GREENROOF

  REAL, DIMENSION(:), ALLOCATABLE :: XLAT_SOIL_TO_GARDEN

  REAL, DIMENSION(:), ALLOCATABLE :: XWATER_ROAD
  REAL, DIMENSION(:), ALLOCATABLE :: XWATER_BLD
  REAL, DIMENSION(:), ALLOCATABLE :: XWATER_GARDEN

  REAL, DIMENSION(:), ALLOCATABLE :: XSEN_MELT_ROAD
  REAL, DIMENSION(:), ALLOCATABLE :: XSEN_MELT_ROOF
  REAL, DIMENSION(:), ALLOCATABLE :: XDIFF_SNOW_WAT_ROAD
  REAL, DIMENSION(:), ALLOCATABLE :: XDIFF_SNOW_WAT_ROOF
  !
  REAL, DIMENSION(:), ALLOCATABLE :: XCONV_LAT_SEN_ROAD
  REAL, DIMENSION(:), ALLOCATABLE :: XCONV_LAT_SEN_ROOF
  !
  REAL, DIMENSION(:), ALLOCATABLE :: XDQS_SNOW_ROOF
  REAL, DIMENSION(:), ALLOCATABLE :: XDQS_SNOW_ROAD
  !
  REAL, DIMENSION(:,:), ALLOCATABLE :: XRHOI ! air density in building compartiments
  !
  REAL, DIMENSION(:), ALLOCATABLE :: XRN   ! net radiation (for this TEB patch)
  REAL, DIMENSION(:), ALLOCATABLE :: XH    ! sensible heat flux radiation (for this TEB patch)
  REAL, DIMENSION(:), ALLOCATABLE :: XLE   ! latent   heat flux radiation (for this TEB patch)
  !
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WALA_TO_ROAD
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WALB_TO_ROAD
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WIND_TO_ROAD
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WALA_TO_GARD
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WALB_TO_GARD
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WIND_TO_GARD
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_ROAD_TO_WIND
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WALL_TO_WIND
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_SNOW_TO_WIND
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_GARD_TO_WIND
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_ROAD_TO_WALA
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_GARD_TO_WALA
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_SNOW_TO_WALA
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WALB_TO_WALA
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WIND_TO_WALA
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_ROAD_TO_WALB
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_GARD_TO_WALB
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_SNOW_TO_WALB
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WALA_TO_WALB
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WIND_TO_WALB
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WALA_TO_SNOW
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WALB_TO_SNOW
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WIND_TO_SNOW
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_ROAD_TO_HV
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WALA_TO_HV
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WALB_TO_HV
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_WIND_TO_HV
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_GARD_TO_HV
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_SNOW_TO_HV
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_HV_TO_ROAD
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_HV_TO_WALA
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_HV_TO_WALB
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_HV_TO_WIND
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_HV_TO_GARD
  REAL, DIMENSION(:), ALLOCATABLE :: XLW_HV_TO_SNOW

END TYPE CHECK_TEB_t

END MODULE MODD_CHECK_TEB
